import { globalLookup } from "./global";

export const sidebarSelectedWires = {
    lastLink: undefined,
    pipeFn: [],
    togglePipe() {
        const lastLink = this.lastLink;
        for (const fn of this.pipeFn) {
            fn(lastLink);
        }
    },

    /**
     * 
     * @param {(link: string) => void} callback 
     */
    addToPipe(callback) {
        this.pipeFn.push(callback);
    },

    has(link) {
        return globalLookup.sidebarSelectedWireLinks.has(link);
    },

    add(link) {
        globalLookup.sidebarSelectedWireLinks.add(link);
        this.lastLink = link;
        this.togglePipe();
    },

    delete(link) {
        globalLookup.sidebarSelectedWireLinks.delete(link);
        if (this.lastLink === link) {
            this.lastLink = undefined;
            for (const link of globalLookup.sidebarSelectedWireLinks) {
                this.lastLink = link;
                break;
            }
        }
        this.togglePipe();
    },

    clear() {
        this.lastLink = undefined;
        globalLookup.sidebarSelectedWireLinks.clear();
        this.togglePipe();
    }
};